RewindableInputStream (Jing API)
Description: declaration: package: com.thaiopensource.validate.auto, class: RewindableInputStream

# Class RewindableInputStream

java.lang.Object
java.io.InputStream
com.thaiopensource.validate.auto.RewindableInputStream

All Implemented Interfaces:
  `Rewindable`, `Closeable`, `AutoCloseable`

public class RewindableInputStream extends InputStream implements Rewindable

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RewindableInputStream(InputStream in)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  `boolean`
  `canRewind()`
  `void`
  `close()`
  `int`
  `read()`
  `int`
  `read(byte[] b, int off, int len)`
  `void`
  `rewind()`
  `void`
  `willNotRewind()`

  ### Methods inherited from class java.io.InputStream

  `mark, markSupported, nullInputStream, read, readAllBytes, readNBytes, readNBytes, reset, skip, skipNBytes, transferTo`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### RewindableInputStream

    public RewindableInputStream(InputStream in)

- ## Method Details

  - ### close

    public void close() throws IOException
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `InputStream`
    Throws:
      `IOException`

  - ### rewind

    public void rewind()
    Specified by:
      `rewind` in interface `Rewindable`

  - ### canRewind

    public boolean canRewind()
    Specified by:
      `canRewind` in interface `Rewindable`

  - ### willNotRewind

    public void willNotRewind()
    Specified by:
      `willNotRewind` in interface `Rewindable`

  - ### read

    public int read() throws IOException
    Specified by:
      `read` in class `InputStream`
    Throws:
      `IOException`

  - ### read

    public int read(byte[] b, int off, int len) throws IOException
    Overrides:
      `read` in class `InputStream`
    Throws:
      `IOException`

  - ### available

    public int available() throws IOException
    Overrides:
      `available` in class `InputStream`
    Throws:
      `IOException`